import { CameraShake } from './enums';
import { Entity } from './models';
import { Vector3 } from './utils';
export declare class Camera {
    private readonly shakeNames;
    private handle;
    constructor(handle: number);
    IsActive: boolean;
    Position: Vector3;
    Rotation: Vector3;
    Direction: Vector3;
    readonly ForwardVector: Vector3;
    FieldOfView: number;
    NearClip: number;
    FarClip: number;
    NearDepthOfField: number;
    FarDepthOfField: number;
    DepthOfFieldStrength: number;
    MotionBlurStrength: number;
    shake(shakeType: CameraShake, amplitude: number): void;
    stopShaking(): void;
    readonly IsShaking: boolean;
    ShakeAmplitude: number;
    pointAt(entity: Entity, offset?: Vector3): void;
    stopPointing(): void;
    interpTo(to: Camera, duration: number, easePosition: boolean, easeRotation: boolean): void;
    readonly IsInterpolating: boolean;
    attachTo(entity: Entity, offset: Vector3): void;
    detach(): void;
    delete(): void;
    exists(): boolean;
}
