import { Vector3 } from './utils';
/**
 * The current rendering gameplay camera
 */
export declare abstract class GameplayCamera {
    /**
     * Get the world position of gameplay camera.
     */
    static readonly Position: Vector3;
    /**
     * Get the rotation of gameplay camera.
     */
    static readonly Rotation: Vector3;
    /**
     * Get the forward vector of gameplay camera.
     */
    static readonly ForwardVector: Vector3;
    /**
     * Get the pitch of the gameplay camera relative to player.
     */
    /**
    * Set gameplay camera pitch relative to player.
    */
    static RelativePitch: number;
    /**
     * Get heading of gameplay camera.
     */
    /**
    * Get heading of gameplay camera.
    */
    RelativeHeading: number;
}
