import { ParticleEffectAsset } from './';
import { IInvertAxis } from './enums';
import { Color, Vector3 } from './utils';
/**
 * UNFINISHED! Class to manage particle effects.
 */
export declare abstract class ParticleEffect {
    protected readonly asset: ParticleEffectAsset;
    protected readonly effectName: string;
    protected offset: Vector3;
    protected rotation: Vector3;
    protected color: Color;
    protected scale: number;
    protected range: number;
    protected invertAxis: IInvertAxis;
    private handle;
    /**
     * Creates a particle effect.
     *
     * @param asset Particle effect asset.
     * @param effectName Name of effect.
     */
    constructor(asset: ParticleEffectAsset, effectName: string);
    /**
     * Get the particle effect handle.
     */
    readonly Handle: number;
    /**
     * Get whether particle effect is currently active.
     */
    readonly IsActive: boolean;
    abstract start(): boolean;
    /**
     * Stop a particle effect.
     */
    stop(): void;
    /**
     * Get the rotation of the particle effect.
     */
    /**
    * Set the rotation of the particle effect.
    */
    Rotation: Vector3;
    /**
     * Get the range of the particle effect.
     */
    /**
    * Set the range of the particle effect.
    */
    Range: number;
    /**
     * Get the invert axis flag of the particle effect.
     */
    /**
    * Set the inverted axis of the particle effect.
    */
    InvertAxis: IInvertAxis;
    /**
     * Set a paramaeter of a particle effect.
     *
     * @param parameterName Name of parameter.
     * @param value Value of parameter.
     */
    setParameter(parameterName: string, value: number): void;
    /**
     * Get the name of the particle effect asset. Same as ParticleEffect.AssetName.
     */
    readonly AssetName: string;
    /**
     * Get the name of the particle effect.
     */
    readonly EffectName: string;
    /**
     * Return the particle effect as string. `AssetName`\\`EffectName`.
     */
    toString(): string;
}
