import { LiteEvent, Size } from '../../utils';
import { UIMenuCheckboxItem, UIMenuItem, UIMenuListItem, UIMenuSliderItem } from './items';
export declare class Menu {
    readonly id: string;
    parentMenu: Menu;
    parentItem: UIMenuItem;
    children: Map<string, Menu>;
    widthOffset: number;
    visible: boolean;
    mouseControlsEnabled: boolean;
    AUDIO_LIBRARY: string;
    AUDIO_UPDOWN: string;
    AUDIO_LEFTRIGHT: string;
    AUDIO_SELECT: string;
    AUDIO_BACK: string;
    AUDIO_ERROR: string;
    menuItems: Array<UIMenuItem | UIMenuListItem | UIMenuSliderItem | UIMenuCheckboxItem>;
    CurrentSelection: number;
    readonly indexChange: LiteEvent;
    readonly listChange: LiteEvent;
    readonly sliderChange: LiteEvent;
    readonly sliderSelect: LiteEvent;
    readonly checkboxChange: LiteEvent;
    readonly itemSelect: LiteEvent;
    readonly menuOpen: LiteEvent;
    readonly menuClose: LiteEvent;
    readonly menuChange: LiteEvent;
    private title;
    private subtitle;
    private counterPretext;
    private counterOverride;
    private spriteLibrary;
    private spriteName;
    private offset;
    private lastUpDownNavigation;
    private lastLeftRightNavigation;
    private activeItem;
    private extraOffset;
    private justOpened;
    private safezoneOffset;
    private maxItemsOnScreen;
    private minItem;
    private maxItem;
    private readonly mainMenu;
    private readonly logo;
    private readonly upAndDownSprite;
    private readonly titleResText;
    private readonly subtitleResText;
    private readonly extraRectangleUp;
    private readonly extraRectangleDown;
    private readonly descriptionBar;
    private readonly descriptionRectangle;
    private readonly descriptionText;
    private readonly counterText;
    private readonly background;
    constructor(title: any, subtitle: any, offset: any, spriteLibrary?: any, spriteName?: any);
    setMenuwidthOffset(widthOffset: number): void;
    addItem(item: UIMenuItem): void;
    refreshIndex(): void;
    clear(): void;
    open(): void;
    close(): void;
    Subtitle: string;
    goLeft(): void;
    goRight(): void;
    selectItem(): void;
    getScreenResolutionMantainRatio(): Size;
    processControl(): void;
    goUpOverflow(): void;
    goUp(): void;
    goDownOverflow(): void;
    goDown(): void;
    goBack(): void;
    bindMenuToItem(menuToBind: Menu, itemToBindTo: UIMenuItem): void;
    releaseMenuFromItem(releaseFrom: UIMenuItem): boolean;
    private recalculateDescriptionPosition;
    private formatDescription;
    private render;
}
