"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class LiteEvent {
    constructor() {
        // tslint:disable-next-line: prefer-array-literal
        this.handlers = [];
    }
    on(handler) {
        this.handlers.push(handler);
    }
    off(handler) {
        // tslint:disable-next-line: ter-arrow-parens
        this.handlers = this.handlers.filter((h) => h !== handler);
    }
    emit(...args) {
        this.handlers.slice(0).forEach((h) => {
            h(...args);
        });
    }
    expose() {
        return this;
    }
}
exports.LiteEvent = LiteEvent;
