"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __1 = require("..");
const Math_1 = require("./Math");
function stringToArray(input) {
    let stringsNeeded = 1;
    if (input.length > 99) {
        stringsNeeded = Math.ceil(input.length % 99 === 0 ? input.length / 99 : input.length / 99 + 1);
    }
    // tslint:disable-next-line: prefer-array-literal
    const outputString = new Array(stringsNeeded);
    for (let i = 0; i < stringsNeeded; i += 1) {
        outputString[i] = input.substring(i * 99, Math_1.clamp(input.substring(i * 99).length, 0, 99));
    }
    return outputString;
}
exports.stringToArray = stringToArray;
function measureStringWidthNoConvert(input) {
    SetTextEntryForWidth('STRING');
    __1.ResText.addLongString(input);
    SetTextFont(0);
    SetTextScale(0.35, 0.35);
    return GetTextScreenWidth(false);
}
exports.measureStringWidthNoConvert = measureStringWidthNoConvert;
function measureString(str) {
    const height = __1.Screen.Height;
    const width = __1.Screen.ScaledWidth;
    return this.measureStringWidthNoConvert(str) * width;
}
exports.measureString = measureString;
